/*****************************************************************************
* Poll1.c - This is polling module Poll1.
\*****************************************************************************/

#include <stdio.h>
#include <rt.h>

#include "MultiThread.h"

/*****************************************************************************
* FUNCTION:			Poll1
* DESCRIPTION: 
*  This is polling thread Poll1.
\*****************************************************************************/
void Poll1(void* param)
{
#ifdef _DEBUG
	fprintf(stderr, "Poll1 started\n");
#endif

	gInit.hAlarmPoll1 = CreateRtAlarm(KN_REPEATER, 5000);
	if (BAD_RTHANDLE == gInit.hAlarmPoll1)
	{
		gInit.hAlarmPoll1 = NULL_RTHANDLE;
		Fail("Cannot create alarm for Poll1");
	}

	// tell that this thread is alive
	gInit.htPoll1	= GetRtThreadHandles(THIS_THREAD);

	// attempt to catalog the thread but ignore error
	Catalog(NULL_RTHANDLE, gInit.htPoll1, "TPoll1");

	while (!gInit.bShutdown)
	{
		if (!WaitForRtAlarm(gInit.hAlarmPoll1, KN_WAIT_FOREVER))
		{
			Fail("Cannot wait for alarm Poll1");
			break;
		}

//#ifdef _DEBUG
//		fprintf(stderr, "Poll1 waking up\n");
//#endif

		// TODO: do what has to be done every 5000 microseconds
		++dwPoll1;
	}

	// tell that this thread is dead
	gInit.htPoll1	= NULL_RTHANDLE;
}
