/*****************************************************************************
* Poll2.c - This is polling module Poll2.
\*****************************************************************************/

#include <stdio.h>
#include <rt.h>

#include "MultiThread.h"

/*****************************************************************************
* FUNCTION:			Poll2
* DESCRIPTION: 
*  This is polling thread Poll2.
\*****************************************************************************/
void Poll2(void* param)
{
#ifdef _DEBUG
	fprintf(stderr, "Poll2 started\n");
#endif

	gInit.hAlarmPoll2 = CreateRtAlarm(KN_REPEATER, 1000);
	if (BAD_RTHANDLE == gInit.hAlarmPoll2)
	{
		gInit.hAlarmPoll2 = NULL_RTHANDLE;
		Fail("Cannot create alarm for Poll2");
	}

	// tell that this thread is alive
	gInit.htPoll2	= GetRtThreadHandles(THIS_THREAD);

	// attempt to catalog the thread but ignore error
	Catalog(NULL_RTHANDLE, gInit.htPoll2, "TPoll2");

	while (!gInit.bShutdown)
	{
		if (!WaitForRtAlarm(gInit.hAlarmPoll2, KN_WAIT_FOREVER))
		{
			Fail("Cannot wait for alarm Poll2");
			break;
		}

//#ifdef _DEBUG
//		fprintf(stderr, "Poll2 waking up\n");
//#endif

		// TODO: do what has to be done every 1000 microseconds
		++dwPoll2;
	}

	// tell that this thread is dead
	gInit.htPoll2	= NULL_RTHANDLE;
}
