/*****************************************************************************
* MY_MBOX_1.c - This is the thread module for MY_MBOX_1.
\*****************************************************************************/

#include <stdio.h>
#include <rt.h>

#include "RTData.h"

/*****************************************************************************
* FUNCTION:			ServerMY_MBOX_1
*
* This is the thread for data mailbox MY_MBOX_1.
\*****************************************************************************/
void ServerMY_MBOX_1(void* param)
{
	WORD			wActual;
	BYTE			byMessage[128];
	RTHANDLE		hMY_MBOX_1;

#ifdef _DEBUG
	fprintf(stderr, "Thread for MY_MBOX_1 started\n");
#endif
	// TODO: modify the flags in the following call if they are not appropriate
	hMY_MBOX_1	= CreateRtMailbox(DATA_MAILBOX | FIFO_QUEUING);
	if (BAD_RTHANDLE == hMY_MBOX_1)
	{
		Fail("Cannot create data mailbox MY_MBOX_1");
		return;
	}
	if (!Catalog(NULL_RTHANDLE, hMY_MBOX_1, "MY_MBOX_1"))
	{
		Fail("Cannot catalog data mailbox MY_MBOX_1");
		return;
	}

	// tell that this thread is alive
	gInit.htMY_MBOX_1	= GetRtThreadHandles(THIS_THREAD);

	// attempt to catalog the thread but ignore error
	Catalog(NULL_RTHANDLE, gInit.htMY_MBOX_1, "TMY_MBOX_1");

	while (!gInit.bShutdown)
	{
#ifdef _DEBUG
		fprintf(stderr, "Thread for MY_MBOX_1 waiting\n");
#endif

		// TODO: modify the timeout in the following call if it is not appropriate
		wActual		= ReceiveRtData(hMY_MBOX_1, byMessage, WAIT_FOREVER);
		if (0 == wActual)
		{
			Fail("Receive from data mailbox MY_MBOX_1 failed");
			break;
		}

		// TODO: operate on byMmessage and dwActual
		//Print the message received from the mail box			//add
		printf("This is the message: %s\n", byMessage);			//add

		//Indicate that the message was received				//add
		SendRtData(hMBOX_Signal, "go", 3);						//add
	}

	// tell that this thread is dead
	gInit.htMY_MBOX_1	= NULL_RTHANDLE;
}
