// main include file for the RTData project

// support functions for all threads
BOOLEAN				Catalog(RTHANDLE hProcess, RTHANDLE hObject, LPSTR lpszName);
void				Cleanup(void);
void				Fail(LPSTR lpszMessage, ...);
DWORD				UsecsToKticks(DWORD dwUsecs);

// global type definitions
typedef enum {
	BEFORE_INIT,
	INIT_BUSY,
	INIT_DONE,
	CLEANUP_BUSY 
}					INIT_STATE;

typedef struct {
	RTHANDLE			hMain;		// RTHANDLE of main thread
	INIT_STATE			state;		// main thread state
	BOOLEAN				bCataloged;	// TRUE if we cataloged process name in root
	BOOLEAN				bShutdown;	// TRUE if all threads have to terminate
	// mailbox and semaphore thread declarations
	RTHANDLE			htMY_MBOX_1;	// RTHANDLE of server thread
	RTHANDLE			htMY_MBOX_2;	// RTHANDLE of server thread
	// client thread declarations
	RTHANDLE			htClient1;	// RTHANDLE of client thread
}					INIT_STRUCT;

// global variables
extern RTHANDLE		hRootProcess;	// RTHANDLE of root process
extern DWORD		dwKtickInUsecs;	// length of one low level tick in usecs
extern RTHANDLE		hMBOX_Signal;							//add
extern INIT_STRUCT	gInit;			// structure describing all global objects

// mailbox and semaphore thread functions
void				ServerMY_MBOX_1(void* param);
void				ServerMY_MBOX_2(void* param);

// client thread functions
void				Client1(void* param);
