/*****************************************************************************
* Client1.c - This is client module Client1.
\*****************************************************************************/

#include <stdio.h>
#include <rt.h>
#include <string.h>

#include "RTSend.h"

/*****************************************************************************
* FUNCTION:		Client1
*
* DESCRIPTION:
*  This is a client thread.
\*****************************************************************************/

// Process and mailbox catalog names
char rt_RTData_process[] = "RTData";
char rt_my_mbx_1[] = "MY_MBOX_1";
char rt_my_mbx_2[] = "MY_MBOX_2";

//#undef _MULTI_NODE_
#define _MULTI_NODE_

void Client1(void* param)
{
	LOCATION		hLoc;
	RTHANDLE		hOtherRoot;
	RTHANDLE		hProcess;
	RTHANDLE		hDmbx;
	RTHANDLE		hRmbx;
	char			nodename[32];
	char			message[128];
	WORD			status;
	WORD			n_recvd;

#ifdef _MULTI_NODE_
	do {
		do {
			printf("Enter the name of the target node: ");
			// Local node: NodeB
			// Local node: ///NodeB
			// Local node: intime:///NodeB
			// Remote DRTOS name: rtoshost.mydomain.com/NodeB
			// Remote DRTOS name: intime:///rtoshost.mydomain.com/NodeB
			// Remote INtime name: host-NodeA.mydomain.com/NodeB
			// Remote INtime name: intime://host-NodeA.mydomain.com/NodeB
			gets(nodename);
			hLoc = GetRtNodeLocationByName(nodename);
			if (BAD_LOCATION == hLoc)
				printf("Could not find location of node \"%s\"\n", nodename);
		} while (BAD_LOCATION == hLoc);

		if ((status = GetRtNodeStatus(hLoc)) != E_OK) {
			printf("Node \"%s\" is not ready: %s\n", nodename, GetRtErrorText(GetLastRtError()));
			continue;
		}
		hOtherRoot = GetRemoteRootRtProcess(hLoc);
		if (BAD_RTHANDLE == hOtherRoot) {
			printf("Could not get remote root process: %s\n", GetRtErrorText(GetLastRtError()));
			continue;
		}
	} while (BAD_RTHANDLE == hOtherRoot);
#else
	hOtherRoot = GetRtThreadHandles(ROOT_PROCESS);
#endif

	// TODO: adjust process and mailbox name
	// TODO: remove the next lines if the data mailbox was created in this process
	hProcess = LookupRtHandle(hOtherRoot, rt_RTData_process, 5000);
	if (BAD_RTHANDLE == hProcess)
	{
		Fail("Cannot find data mailbox process");
		return;
	}

	// TODO: replace hProcess by NULL_RTHANDLE if the data mailbox was created in this process
	// Look up MY_MBOX_1
	hDmbx = LookupRtHandle(hProcess, rt_my_mbx_1, 5000);
	if (BAD_RTHANDLE == hDmbx)
	{
		Fail("Cannot find data mailbox 1");
		return;
	}

	// Look up MY_MBOX_2
	hRmbx = LookupRtHandle(hProcess, rt_my_mbx_2, 5000);
	if (BAD_RTHANDLE == hRmbx)
	{
		Fail("Cannot find data mailbox 2");
		return;
	}

	// tell that this thread is alive
	gInit.htClient1	= GetRtThreadHandles(THIS_THREAD);

	// attempt to catalog the thread but ignore error
	Catalog(NULL_RTHANDLE, gInit.htClient1, "TClient1");

	while (!gInit.bShutdown)
	{
		// TODO: put client code that must be repeated here
		// prompt the user for a message
		printf("\nType a message: ");
		gets(message);

		// send the message
		SendRtData(hDmbx, message, 128);

		// receive a response message
		n_recvd = ReceiveRtData(hRmbx, message, WAIT_FOREVER);
		if (n_recvd == 0) {
			break;
		}
		printf("Received %u bytes: \"%s\"\n", n_recvd, message);
	}

	Fail("Failed to receive message from mailbox 2\n");

	// tell that this thread is dead
	gInit.htClient1	= NULL_RTHANDLE;
}
